function [liste_p,liste_q] = RK_4(p0,q0,dt,T)

liste_p = [p0];
liste_q = [q0];


N = floor(T/dt);

qaux = q0;
paux = p0;

for i = 1:N
    q1 = dhdp(qaux,paux);
    p1 = -dhdq(qaux,paux);
    
    q2 = dhdp(qaux+dt/2*q1,paux+dt/2*p1);
    p2 = -dhdq(qaux+dt/2*q1,paux+dt/2*p1);
        
    q3 = dhdp(qaux+dt/2*q2,paux+dt/2*p2);
    p3 = -dhdq(qaux+dt/2*q2,paux+dt/2*p2);

    q4 = dhdp(qaux+dt*q3,paux+dt*p3);
    p4 = -dhdq(qaux+dt*q3,paux+dt*p3);

    qaux2 = qaux + dt/6*(q1+2*q2+2*q3+q4);
    

    paux2 = paux + dt/6*(p1+2*p2+2*p3+p4);
   
    
    liste_p = [liste_p, paux2];
    liste_q = [liste_q, qaux2];
    
    qaux = qaux2;
    paux = paux2;
end

