close all;
clc;

p0=3*[0;1];
q0=[1;0];
dt = 0.001;
T = 10;

[liste_p,liste_q] = Euler_E(p0,q0,dt,T);

x0 = q0(1);
y0 = q0(2);
x = liste_q(1,:);
y = liste_q(2,:);

plot(x,y,0,0,'rd',x0,y0,'gd');
axis equal;
legend('Trajectoire','Soleil','Position initiale');
title('Kpler par Euler explicite, T = 10, dt = 0.001');
xlabel('q1');
ylabel('q2');
disp('Mme avec dt=0.01 on constate un grand dfaut, les trajectoires sont loin de se refermer : la distance plante-soleil diverge');

disp('Appuyez sur une touche pour passer  la suite');
disp('----------');
pause;

figure;

[liste_pRK,liste_qRK] = RK_4(p0,q0,dt,T);

x = liste_qRK(1,:);
y = liste_qRK(2,:);


plot(x,y,0,0,'rd',x0,y0,'gd');
axis equal;
legend('Trajectoire','Soleil','Position initiale');
title('Kpler par RK4, T = 10, dt = 0.001');
disp('Avec RK4 la trajectoire est bien plus prcise, on voit une ellipse, mais on voit aussi le trac un peu gras : la distance croit encore, seulement, beaucoup plus lentement');
disp('On pourrait changer les paramtres pour voir RK4 exploser aussi');
disp('Appuyez sur une touche pour passer  la suite');
disp('------------');
pause;

figure;

[liste_pS,liste_qS] = Euler_S(p0,q0,dt,T); 
x = liste_qS(1,:);
y = liste_qS(2,:);

plot(x,y,0,0,'rd',x0,y0,'gd');
axis equal;
legend('Trajectoire','Soleil','Position initiale');
xlabel('q1');
ylabel('q2');
title('Kpler par Euler symplectique, T = 10, dt = 0.001');
disp('Le trac est un peu plus gras que RK4, mais la mthode n"est que d"ordre 1. En diminuant dt on peut constater que la compacit des trajectoires est meilleuer avec cette mthode qu"avec RK4. On peut aussi le voir si on trace le hamiltonien dans le temps');
disp('Appuyez sur une touche pour passer  la suite');
disp('---------------');

disp('Suite : essayez de remplacer mu=10 par mu=80 dans dhdq.m : Euler_E et RK_4 divergent compltement. Euler_S donne une superposition chaotique d"ellipses diffrentes');
disp('Testez aussi la dpendance aux donnes initiales : le systme y est sensible. C"est ce qu"avait observ Poincar  la main dj  l"poque (sur le problme  trois corps, ce qui est encore bien pire).');
